// RPLLAB, copyright (C) 1998 Yale Kozinski
// Aids in converting QBASIC to USER-RPL

#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <stdlib.h>

void WriteAgain( );  // Performs writes


ifstream infile;
ofstream outfile;

char temp[255], name[255];  // Temporary buffer
int depth = 0; // \<< \>> Depth



int main( int argc, char *argv[] )
{
if( argc != 4 ) // Takes 3 args
	{
	cout << "Syntax: RPLLAB infile outfile main_function_name\n";
	exit( 1 );  // Error 1 = Wrong num of args
	}
infile.open ( argv[1] );  // Open specified file
if ( !infile )  // If it failed to open...
	{
	cout << "Invalid input file!\n";

	exit ( 2 );  // Error 2 = Invalid infile
	}
outfile.open ( argv[2] ); // Open output file
if ( !outfile )  // Output file could not be opened...
	{
	cout << "Failed to open output file!\n";
	infile.close ( );
	exit ( 3 ); // Error 3 = Output file could not be written
	}
outfile << "\\<<" << endl;
strcpy( name, argv[3] );
WriteAgain( );
outfile << "'" << name << "'" << endl << " STO " << endl << "\\>>";
infile.close( );
outfile.close( );
return 0;
}

void WriteAgain( )
{
while ( !infile.eof( )) // While not the end of infile
	{
	infile >> temp; // First check to see if it's a keyword
	if ( strncmpi ( temp, "GLABEL", 6 ) == 0 )
		{
		if ( infile.eof( ) )
			{
			cout << "Premature end of file!";
			infile.close ( );
			outfile.close ( );
			exit ( 4 ); // Error 4 = Premature end of file
			}
		infile >> temp;
		if (depth != 1)
			{
			cout << "Warning!  Label definiton \"" << temp
			<< "\" not in top level!";
			}
		outfile << temp << endl << "\\>>" << endl << "'" << name << "' STO"
		<< endl << "\\<<" << endl;
		strcpy( name, temp );
		WriteAgain( );
		}
	else if ( strncmpi ( temp, "GOTOGL", 6 ) == 0 )
		{
		if ( infile.eof( ) )
			{
			cout << "Premature end of file!";
			infile.close ( );
			outfile.close ( );
			exit ( 4 ); // Error 4 = Premature end of file
			}
		infile >> temp;
		outfile << "#6FD1h SYSEVAL " << temp << endl;
		}
	else if ( strncmpi ( temp, "\\<<", 3 ) == 0 )
		{
		depth++;
		outfile << temp << endl;
		}
	else if ( strncmpi ( temp, "\>>", 3 ) == 0 )
		{
		depth--;
		outfile << temp << endl;
		}
	else
		{
		outfile << temp << endl;
		}
	}
}
